Attribute VB_Name = "mWheel"


Option Explicit


Private m_OldWindowProc As Long


Public Const WM_MOUSEWHEEL As Long = &H20A
Private Const GWL_WNDPROC As Long = (-4)


Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
                            (ByVal hWnd As Long, _
                             ByVal nIndex As Long, _
                             ByVal dwNewLong As Long) As Long
                             
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
                            (ByVal lpPrevWndFunc As Long, _
                             ByVal hWnd As Long, _
                             ByVal Msg As Long, _
                             ByVal wParam As Long, _
                             ByVal lParam As Long) As Long


' Subclasses the mouse wheel for frmSample
Public Sub Subclass(ByVal hWnd As Long)

  On Error Resume Next

    ' Set new Window proc and get old one
    m_OldWindowProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf WindowProc)
    
End Sub






















































' Processes wheel messages to zoom in/out
Private Function WindowProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
  On Error Resume Next

    ' Filter messages
    Select Case wMsg
        ' Mouse wheel scrolled
        Case WM_MOUSEWHEEL
            ' Zoom in/out
            ' -------------------------
            ' Up
            If wParam > 0 Then
                ' Zoom in
                Call frmSample.ZoomIn
                ' Down
                 Else
                ' Zoom out
                Call frmSample.ZoomOut
            End If
            ' -------------------------
    End Select
    
    ' Return
    WindowProc = CallWindowProc(m_OldWindowProc, hWnd, wMsg, wParam, lParam)
    
End Function
